package com.gic.enterprise.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.enterprise.dto.BillingPayInfoDTO;
import com.gic.enterprise.dto.InvoiceDTO;
import com.gic.enterprise.qo.BillListQueryQO;
/**
 * 支付信息
 * @ClassName: BillingPayInfoApiService 
 * @Description:  
 * @author guojuxing 
 * @date 2019/8/15 1:53 PM 
 */
public interface BillingPayInfoApiService {

    /**
     * 分页查询为开票单据列表数据
     * @Title: listBill 
     * @Description:
      * @author guojuxing
     * @param params 
     * @return  com.gic.api.base.commons.ServiceResponse<com.gic.api.base.commons.Page<com.gic.enterprise.dto.BillingPayInfoDTO>> 
      */
    ServiceResponse<Page<BillingPayInfoDTO>> listBill(BillListQueryQO params);

    /**
     * 从redis获取开票申请中的开户相关信息
     * @Title: getInvoiceInfoFromRedis 
     * @Description:
      * @author guojuxing
     * @param enterpriseId 
     * @return  com.gic.api.base.commons.ServiceResponse<com.gic.enterprise.dto.InvoiceDTO> 
      */
    ServiceResponse<InvoiceDTO> getInvoiceInfoFromRedis(Integer enterpriseId);

    /**
     * 预支付，生成二维码, 保存支付信息
     * @Title: savePrePayInfo
     * @Description:
     * @author zhiwj
     * @param enterpriseId 企业id
     * @param serialNumber 唯一流水号
     * @param totalFee 充值金额
     * @param payType 支付方式
     * @param buyType 2:短信套餐包购买 1:商户余额充值
     * @return com.gic.enterprise.dto.BillingPayInfoDTO  codeUrl:二维码url
     * @throws
     */
    ServiceResponse<BillingPayInfoDTO> savePrePayInfo(Integer enterpriseId, String serialNumber, Double totalFee, Integer payType, Integer buyType);

    /**
     * 查询支付状态
     * @Title: queryPayStatus
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param serialNumber
     * @param payType
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Integer>
     * @throws
     */
    ServiceResponse<Integer> queryPayStatus(Integer enterpriseId, String serialNumber, Integer payType);
}
