package com.gic.enterprise.service.impl;

import com.gic.commons.util.DateUtil;
import com.gic.commons.util.EntityUtil;
import com.gic.enterprise.dao.mapper.TabBillingPayInfoMapper;
import com.gic.enterprise.dto.BillingPayInfoDTO;
import com.gic.enterprise.entity.TabBillingPayInfo;
import com.gic.enterprise.qo.BillListQueryQO;
import com.gic.enterprise.service.BillingPayInfoService;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service("billingPayInfoService")
public class BillingPayInfoServiceImpl implements BillingPayInfoService{
    @Autowired
    private TabBillingPayInfoMapper tabBillingPayInfoMapper;
    @Override
    public TabBillingPayInfo getById(Integer billingPayInfoId) {
        return tabBillingPayInfoMapper.selectByPrimaryKey(billingPayInfoId);
    }

    @Override
    public Page<TabBillingPayInfo> listBilling(BillListQueryQO params) {
        PageHelper.startPage(params.getCurrentPage(), params.getPageSize());
        List<TabBillingPayInfo> list = tabBillingPayInfoMapper.listBill(params);
        return (Page<TabBillingPayInfo>) list;
    }

    @Override
    public Integer savePayInfo(BillingPayInfoDTO billingPayInfoDTO) {
        TabBillingPayInfo tabBillingPayInfo = EntityUtil.changeEntityByOrika(TabBillingPayInfo.class, billingPayInfoDTO);
        return tabBillingPayInfoMapper.insertSelective(tabBillingPayInfo);
    }

    @Override
    public Integer updatePayInfoBySerialNumber(Integer enterpriseId, String serialNumber, Integer resultCode, String errCode, String errCodeDes) {
        TabBillingPayInfo tabBillingPayInfo = new TabBillingPayInfo();
        tabBillingPayInfo.setEnterpriseId(enterpriseId);
        tabBillingPayInfo.setTimeEnd(DateUtil.formatString(new Date(), DateUtil.FORMAT_DATETIME_14));
        tabBillingPayInfo.setSerialNumber(serialNumber);
        tabBillingPayInfo.setResultCode(resultCode);
        tabBillingPayInfo.setErrCode(errCode);
        tabBillingPayInfo.setErrCodeDes(errCodeDes);
        tabBillingPayInfoMapper.updateBySerialNumber(tabBillingPayInfo);
        return tabBillingPayInfo.getPayInfoId();
    }

}
