package com.gic.enterprise.service.impl;

import com.gic.commons.util.GlobalInfo;
import com.gic.enterprise.constant.BillingAuditStatusEnum;
import com.gic.enterprise.constant.PayTypeEnum;
import com.gic.enterprise.dao.mapper.TabBillingRechargeRecordMapper;
import com.gic.enterprise.dto.BillingRechargeDTO;
import com.gic.enterprise.entity.TabBillingRechargeRecord;
import com.gic.enterprise.service.BillingRechargeRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019/8/15 17:05
 */
@Service
public class BillingRechargeRecordServiceImpl implements BillingRechargeRecordService {

    @Autowired
    private TabBillingRechargeRecordMapper tabBillingRechargeRecordMapper;

    @Override
    public Integer saveOffLinePay(BillingRechargeDTO billingRechargeDTO) {
        TabBillingRechargeRecord rechargeRecord = new TabBillingRechargeRecord();
        rechargeRecord.setEnterpriseId(billingRechargeDTO.getEnterpriseId());
        rechargeRecord.setSerialNumber(billingRechargeDTO.getSerialNumber());
        rechargeRecord.setTotalFee(billingRechargeDTO.getTotalFee());
        rechargeRecord.setPayType(PayTypeEnum.OFFLINE_PAY.getCode());
        rechargeRecord.setStatus(GlobalInfo.DATA_STATUS_NORMAL);
        rechargeRecord.setInitiator(billingRechargeDTO.getInitiator());
        rechargeRecord.setInitiatorUser(billingRechargeDTO.getInitiatorUser());
        rechargeRecord.setAuditStatus(BillingAuditStatusEnum.AUDITING.getCode());
        rechargeRecord.setOperator(billingRechargeDTO.getOperator());
        rechargeRecord.setVerificationCode(billingRechargeDTO.getVerificationCode());
        rechargeRecord.setCreateTime(new Date());
        tabBillingRechargeRecordMapper.insertSelective(rechargeRecord);
        return rechargeRecord.getRechargeRecordId();
    }

    @Override
    public Integer saveWxPay(BillingRechargeDTO billingRechargeDTO) {
        TabBillingRechargeRecord rechargeRecord = new TabBillingRechargeRecord();
        rechargeRecord.setEnterpriseId(billingRechargeDTO.getEnterpriseId());
        rechargeRecord.setSerialNumber(billingRechargeDTO.getSerialNumber());
        rechargeRecord.setTotalFee(billingRechargeDTO.getTotalFee());
        rechargeRecord.setTotalFeePaid(billingRechargeDTO.getTotalFeePaid());
        rechargeRecord.setPayType(PayTypeEnum.WE_CHAT_PAY.getCode());
        rechargeRecord.setStatus(GlobalInfo.DATA_STATUS_NORMAL);
        rechargeRecord.setInitiator(billingRechargeDTO.getInitiator());
        rechargeRecord.setInitiatorUser(billingRechargeDTO.getInitiatorUser());
        rechargeRecord.setAuditStatus(BillingAuditStatusEnum.WAIT_PAY.getCode());
        rechargeRecord.setOperator(billingRechargeDTO.getOperator());
        rechargeRecord.setVerificationCode(billingRechargeDTO.getVerificationCode());
        rechargeRecord.setCreateTime(new Date());
        tabBillingRechargeRecordMapper.insertSelective(rechargeRecord);
        return rechargeRecord.getRechargeRecordId();
    }

    @Override
    public void updateRechargeRecordBySerialNumber(BillingRechargeDTO billingRechargeDTO) {

    }
}
