package com.gic.enterprise.service.outer;

import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.enterprise.constant.PayTypeEnum;
import com.gic.enterprise.dto.BillingRechargeDTO;
import com.gic.enterprise.error.ErrorCode;
import com.gic.enterprise.service.BillingPayInfoApiService;
import com.gic.enterprise.service.BillingPayInfoService;
import com.gic.enterprise.service.BillingRechargeApiService;
import com.gic.enterprise.service.BillingRechargeRecordService;
import com.gic.thirdparty.api.service.Pay4WXService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 *
 * @ClassName: BillingRechargeApiServiceImpl
 * @Description:
 * @author zhiwj
 * @date 2019/8/15 17:05
 */
@Service("billingRechargeApiService")
public class BillingRechargeApiServiceImpl implements BillingRechargeApiService {

    @Autowired
    private BillingRechargeRecordService billingRechargeRecordService;
    @Autowired
    private Pay4WXService pay4WXService;
    @Autowired
    private BillingPayInfoApiService billingPayInfoApiService;
    @Autowired
    private BillingPayInfoService billingPayInfoService;

    @Override
    public ServiceResponse<JSONObject> selectPaymentMethod(BillingRechargeDTO billingRechargeDTO) {
//        String serialNumber = CreateSerialNumberUtils.createSerialNumber();
//        BillingPayInfoDTO billingPayInfoDTO = billingPayInfoApiService.savePrePayInfo(billingRechargeDTO.getEnterpriseId(), serialNumber, billingRechargeDTO.getTotalFee(), PayTypeEnum.WE_CHAT_PAY.getCode(), BuyTypeEnum.BALANCE_RECHARGE.getCode());
//        if (PayTypeEnum.ALI_PAY.getCode() == billingRechargeDTO.getPayType()) {
//            // 支付宝
//            return ServiceResponse.success();
//        } else if (PayTypeEnum.WE_CHAT_PAY.getCode() == billingRechargeDTO.getPayType()) {
//            // 微信支付
//            // 生成唯一流水号
//            // 生成充值记录
//            billingRechargeDTO.setPayInfoId(billingPayInfoDTO.getPayInfoId());
//            billingRechargeDTO.setSerialNumber(serialNumber);
//            billingRechargeRecordService.saveWxPay(billingRechargeDTO);
//            return ServiceResponse.success();
//        } else {
//            return ServiceResponse.failure(ErrorCode.PARAMETER_ERROR.getCode(), "不存在该支付类型");
//        }
        return null;
    }

    @Override
    public ServiceResponse<Integer> afterPay(BillingRechargeDTO billingRechargeDTO) {
        if (PayTypeEnum.OFFLINE_PAY.getCode() == billingRechargeDTO.getPayType()) {
            // 银行对公转账
            billingRechargeRecordService.saveOffLinePay(billingRechargeDTO);
            // todo 发起审批
            return ServiceResponse.success();
        } else if (PayTypeEnum.ALI_PAY.getCode() == billingRechargeDTO.getPayType()) {
            // 支付宝
            return ServiceResponse.success();
        } else if (PayTypeEnum.WE_CHAT_PAY.getCode() == billingRechargeDTO.getPayType()) {
            // 微信支付
//            billingRechargeRecordService
            // 更新支付信息
//            billingPayInfoService.updatePayInfoBySerialNumber(billingRechargeDTO);
            // 更新充值记录
            billingRechargeRecordService.updateRechargeRecordBySerialNumber(billingRechargeDTO);
            return ServiceResponse.success();
        } else {
            return ServiceResponse.failure(ErrorCode.PARAMETER_ERROR.getCode(), "不存在该支付类型");
        }
    }

    @Override
    public ServiceResponse<Integer> updateRecharge(BillingRechargeDTO billingRechargeDTO) {
        return null;
    }
}
